#!/bin/bash

# TRABALHO DE LINGUAGENS DE PROGRAMAÇÃO.
# ALUNOS: GIULIANO LACERDA E ANDRÉ LUIZ
# PROFESSOR Vítor E. Silva Souza


# A EXECUCAO DO PROGRAMA OCORRE DA SEGUINTE FORMA NO TERMINAL:
# chmod +x trabalho.sh
# diretório./trabalho.sh -c clientes.csv -f fornecedores.csv -p produtos.cs        ./trabalho.sh -c clientes.csv -f fornecedores.csv -p produtos.csv -a compras.csv -v vendas.csv


cadastro_de_fornecedores()
{
	linha=0;
	
	#PERCORRE O ARQUIVO POR LINHAS ATÉ A ULTIMA LINHA. ARMAZENA CADA LINHA PROVISORIAMENTE EM $line
	#A VARIAVEL IFS=$'\n' DETERMINA QUE CADA INFORMACAO QUE QUEREMOS PEGAR ESTAO SEPARADAS POR QUEBRAS DE LINHA.
	while IFS=$'\n' read -r line || [[ -n "$line" ]]
	
	do  
		
		if [ $linha != 0 ]
		then
		    # VARIAVEL CODIGO ONDE ARMAZENAMOS PROVISORIAMENTE O CODIGO DO FORNECEDOR.
		    # O METODO CUT COM O PARAMETRO -d';' DETERMINA QUE AS INFORMACOES QUE QUEREMOS PEGAR NAS LINHAS ESTAO SEPARADAS POR ;
			codigo=(`echo $line | cut -d';' -f1`)
			
			# VARIAVEL NOME ONDE ARMAZENAMOS PROVISORIAMENTE O NOME DO FORNCEDOR.
			nome=(`echo $line | cut -d';' -f2`)
			
			# VARIAVEL ENDERECO ONDE ARMAZENAMOS PROVISORIAMENTE O END. DO FORNECEDOR.
			endereco=(`echo $line | cut -d';' -f3`)
			
			#VARIAVEL TELEFONE ONDE ARMAZENAMOS PROVISORIAMENTE O TELEFONE DO FORNECEDOR.
			telefone=(`echo $line | cut -d';' -f4`)
			
			#VARIAVEL CNPJ ONDE ARMAZENAMOS PROVISORIAMENTE O CNPJ DO FORNECEDOR.
			cnpj=(`echo $line | cut -d';' -f5`)
			
			#VARIAVEL CONTATO ONDE ARMAZENAMOS PROVISORIAMENTE O CONTATO DO FORNECEDOR.
			contato=(`echo $line | cut -d';' -f6`)
			
			#VARIAVEL TOTAL A PAGAR ONDE ARMAZENAMOS PROVISORIAMENTE O TOTAL A PAGAR PARA O FORNECEDOR.
			total_a_pagar=0
			
			#CONCATENAMOS TODOS OS ATRIBUTOS DO FORNECEDOR EM UMA STRING.
			string="$codigo $nome $endereco $telefone $cnpj $contato $total_a_pagar"
			#echo $string;
			
			
			#CADA POSICAO DO VETOR_DE_FORNECEDORES SÃO INFORMACÕES SOBRE CADA FORNECEDOR.
			vetor_de_fornecedores[$linha]=$string;
		    
			
			
		fi 
		let linha=$linha+1;
		
		
		#echo ${vetor_de_fornecedores[@]}
		#AQUI NÓS TEMOS UM VETOR DE VETORES. ONDE CADA SUBVETOR É UM VETOR COM AS INFORMAÇÕES DE UM
		#DETERMINADO FORNECEDOR.
		
	done
}

cadastro_de_clientes()
{
	linha=0;
	
	#PERCORRE O ARQUIVO POR LINHAS ATÉ A ULTIMA LINHA. ARMAZENA CADA LINHA PROVISORIAMENTE EM $line
	#A VARIAVEL IFS=$'\n' DETERMINA QUE CADA INFORMACAO QUE QUEREMOS PEGAR ESTAO SEPARADAS POR QUEBRAS DE LINHA.
	while IFS=$'\n' read -r line || [[ -n "$line" ]]
	
	do  
		
		if [ $linha != 0 ]
		then
		    
			codigo=(`echo $line | cut -d';' -f1`)
			nome=(`echo $line | cut -d';' -f2`)
			endereco=(`echo $line | cut -d';' -f3 | sed 's/ //g'`)
			telefone=(`echo $line | cut -d';' -f4`)
			data=(`echo $line | cut -d';' -f5`)
			tipo=(`echo $line | cut -d';' -f6`)
			cpf_cnpj=(`echo $line | cut -d';' -f7`)
			if [ $tipo == "J" ]
			then
				IE=(`echo $line | cut -d';' -f8`)
			else
				IE=0
			fi
			a_cobrar=0
			
			string="$codigo $nome $endereco $telefone $data $tipo $cpf_cnpj $IE $a_cobrar"
			
			vetor_de_clientes[$linha]=$string;
		    
			
			
		fi 
		let linha=$linha+1;
		
	done
}

cadastro_de_produtos()
#Código;Descrição;Estoque mínimo;Estoque atual;Valor de custo;Percentual de lucro
{
	linha=0;
	
	#PERCORRE O ARQUIVO POR LINHAS ATÉ A ULTIMA LINHA. ARMAZENA CADA LINHA PROVISORIAMENTE EM $line
	#A VARIAVEL IFS=$'\n' DETERMINA QUE CADA INFORMACAO QUE QUEREMOS PEGAR ESTAO SEPARADAS POR QUEBRAS DE LINHA.
	while IFS=$'\n' read -r line || [[ -n "$line" ]]
	
	do  
		
		if [ $linha != 0 ]
		then
		    
			codigo=(`echo $line | cut -d';' -f1`)
			descricao=(`echo $line | cut -d';' -f2`)
			estoque_minimo=(`echo $line | cut -d';' -f3`)
			estoque_atual=(`echo $line | cut -d';' -f4`)
			valor_de_custo=(`echo $line | cut -d';' -f5`)
			valor_de_custo1=(`echo $valor_de_custo | cut -d',' -f1`)
			
			# SE O NUMERO NÃO TIVER VIRGULA, ENTAO O VALOR_DE_CUSTO SERA IGUAL AO VALOR_DE_CUSTO1.
			if [ $valor_de_custo == $valor_de_custo1 ]
			# ENTAO O VALOR DE CUSTO É APENAS O VALOR SEM PONTO.
			then
				valor_de_custo=(`echo $line | cut -d';' -f5`)
			# SE NÃO, O VALOR DE CUSTO SERA A CONCATENACAO DO VALOR ANTES DA VIRGULA COM O "." COM O VALOR DEPOIS DA VIRGULA.
			# CONVERTENDO DE A,B -> A.B
			else
				valor_de_custo2=(`echo $valor_de_custo | cut -d',' -f2`)
				valor_de_custo="$valor_de_custo1.$valor_de_custo2"
			fi
			#echo $valor_de_custo
			percentual_lucro=(`echo $line | cut -d';' -f6`)
			
			# CONVERTENDO PERCENTUAL DE LUCRO XY -> 0.XY
			percentual_lucro=`echo "scale=2; $percentual_lucro/100" | bc`
			#echo $percentual_lucro
			
			# CALCULO DO VALOR_DE_VENDA COM BASE NO VALOR DE CUSTO E PERCENTUAL DE LUCRO.
			valor_de_venda=`echo "scale=2; $valor_de_custo+($valor_de_custo * $percentual_lucro)" | bc`
			#echo $valor_de_venda;
			
			string="$codigo $descricao $estoque_minimo $estoque_atual $valor_de_custo $percentual_lucro $valor_de_venda"
			
			vetor_de_produtos[$linha]=$string;
		    
			
			
		fi 
		let linha=$linha+1;
		
	done
}

cadastro_de_compras()
#Nota fiscal;Codigo do Fornecedor;Data da compra;Codigo do Produto;Quantidade
{
	
	linha=0;
	
	#PERCORRE O ARQUIVO POR LINHAS ATÉ A ULTIMA LINHA. ARMAZENA CADA LINHA PROVISORIAMENTE EM $line
	#A VARIAVEL IFS=$'\n' DETERMINA QUE CADA INFORMACAO QUE QUEREMOS PEGAR ESTAO SEPARADAS POR QUEBRAS DE LINHA.
	while IFS=$'\n' read -r line || [[ -n "$line" ]]
	
	do  
		
		if [ $linha != 0 ]
		then
		    
			nota_fiscal=(`echo $line | cut -d';' -f1`)
			codigo_fornecedor=(`echo $line | cut -d';' -f2`)
			data_compra=(`echo $line | cut -d';' -f3`)
			codigo_produto=(`echo $line | cut -d';' -f4`)
			quantidade=(`echo $line | cut -d';' -f5`)
			
			# PERCORREMOS TODOS OS ELEMENTOS DO VETOR DE PRODUTOS TRANTANDO CADA ELEMENTO DESTE VETOR.
			for j in ${!vetor_de_produtos[*]}
			do
				# PEGAMOS O ELEMENTO DO VETOR E O SALVAMOS EM UMA STRING "PRODUTO_COMO_STRING"	
				produto_como_string=${vetor_de_produtos[$j]}
				
				# DEPOIS, CONVERTEMOS ESTA STRING PARA UM VETOR "PRODUTO_COMO_VETOR" 
				produto_como_vetor=(${produto_como_string})
				
				# AGORA PODEMOS ANALISAR OS ELEMENTOS DESTE PRODUTO. VERIFICAMOS SE ESTE PRODUTO É O QUE QUEREMOS,
				# SE SIM, ENTAO PEGAMOS O SEU VALOR DE CUSTO E MULTIPLICAMOS PELA QUANTIDADE INFORMADA NA NOTA.
				#echo ${produto_como_vetor[@]}
				#echo $codigo_produto
				
				if [ ${produto_como_vetor[0]} == "$codigo_produto" ]
				then
					#echo $custo_do_produto
					#echo $quantidade
					# CALCULA O VALOR TOTAL DA NOTA COM BASE NA QUANTIDADE E NO PRECO DE CUSTO DO PRODUTO
					total_da_nota=`echo "scale=2; ${produto_como_vetor[4]}*$quantidade" | bc`
					#echo $total_da_nota
				fi
			done
		
			
			string="$nota_fiscal $codigo_fornecedor $data_compra $codigo_produto $quantidade $total_da_nota"
			
			vetor_de_compras[$linha]=$string;
		    
			
			
		fi 
		let linha=$linha+1;
		
	done
}

# GERA RELATÓRIO DE TOTAL QUE DEVE SER PAGO AOS FORNECEDORES
relatorio_total_a_pagar()
{
	for j in ${!vetor_de_compras[*]}
	do
		# PEGA A PRIMEIRA STRING DO VETOR_DE_COMPRAS E ARMAZENA NA STRING COMPRA_COMO_STRING
		compra_como_string=${vetor_de_compras[$j]}
		
		# CONVERTE ESTA STRING PARA VETOR. PARA FACILITAR O ACESSO AOS DADOS DESTA COMPRA
		compra_como_vetor=(${compra_como_string})
		
		for i in ${!vetor_de_fornecedores[*]}
		do
			
			fornecedor_como_string=${vetor_de_fornecedores[$i]}
			
			fornecedor_como_vetor=(${fornecedor_como_string})
			
			# COMPARA O CODIGO DO FORNECEDOR QUE ESTA NO VETOR COMPRA COM O CODIGO DE CADA FORNECEDOR DO VETOR DE FORNECEDORES
			if [ ${compra_como_vetor[1]} == ${fornecedor_como_vetor[0]} ]
			then 
				# CASO ENCONTREMOS O FORNECEDOR QUE QUEREMOS, ALTERAMOS O TOTAL A PAGAR SOMANDO ELE MESMO COM O VALOR DA NOTA.
				fornecedor_como_vetor[6]=`echo "scale=2; ${fornecedor_como_vetor[6]}+${compra_como_vetor[5]}" | bc`
				
				# DEPOIS SUBSTITUIMOS O VETOR QUE AGORA ESTA ATUALIZADO EM SUA POSICAO ORIGINAL NO VETOR DE FORNECEDORES.
				fornecedor_como_string=${fornecedor_como_vetor[@]}
				vetor_de_fornecedores[$i]=$fornecedor_como_string
			fi
		done
	done
	
	echo "FORNECEDOR;CNPJ;PESSOA DE CONTATO ;TELEFONE;TOTAL A PAGAR" > 1-apagar.csv
	for j in ${!vetor_de_fornecedores[*]}
	do
		fornecedor_como_string=${vetor_de_fornecedores[$j]}
		fornecedor_como_vetor=(${fornecedor_como_string})
		
		echo ${fornecedor_como_vetor[1]}";"${fornecedor_como_vetor[2]}";"${fornecedor_como_vetor[3]}";"${fornecedor_como_vetor[4]}";"${fornecedor_como_vetor[5]}";"${fornecedor_como_vetor[6]} >> 1-apagarteste.csv
		sort 1-apagarteste.csv > 1-apagar.csv # ORGANIZA A SAÍDA POR ORDEM ALFABÉTICA.
		
	done
	
	
}

cadastro_de_vendas()
#Cliente;Data de venda;Produto;Quantidade;Modo de pagamento
{
	linha=0;
	
	#PERCORRE O ARQUIVO POR LINHAS ATÉ A ULTIMA LINHA. ARMAZENA CADA LINHA PROVISORIAMENTE EM $line
	#A VARIAVEL IFS=$'\n' DETERMINA QUE CADA INFORMACAO QUE QUEREMOS PEGAR ESTAO SEPARADAS POR QUEBRAS DE LINHA.
	while IFS=$'\n' read -r line || [[ -n "$line" ]]
	
	do  
		
		if [ $linha != 0 ]
		then
		    
			codigo_cliente=(`echo $line | cut -d';' -f1`)
			data_da_venda=(`echo $line | cut -d';' -f2`)
			codigo_produto=(`echo $line | cut -d';' -f3`)
			quantidade=(`echo $line | cut -d';' -f4`)
			modo_de_pagamento=(`echo $line | cut -d';' -f5`)
			
			for j in ${!vetor_de_produtos[*]}
			do
				# PEGAMOS O ELEMENTO DO VETOR E O SALVAMOS EM UMA STRING "PRODUTO_COMO_STRING"	
				produto_como_string=${vetor_de_produtos[$j]}
				
				# DEPOIS, CONVERTEMOS ESTA STRING PARA UM VETOR "PRODUTO_COMO_VETOR" 
				produto_como_vetor=(${produto_como_string})
				
				# AGORA PODEMOS ANALISAR OS ELEMENTOS DESTE PRODUTO. VERIFICAMOS SE ESTE PRODUTO É O QUE QUEREMOS,
				# SE SIM, ENTAO PEGAMOS O SEU VALOR DE CUSTO E MULTIPLICAMOS PELA QUANTIDADE INFORMADA NA NOTA.
				#echo ${produto_como_vetor[@]}
				#echo $codigo_produto
				
				if [ ${produto_como_vetor[0]} == "$codigo_produto" ]
				then
					#echo $custo_do_produto
					#echo $quantidade
					valor_total=`echo "scale=2; ${produto_como_vetor[6]}*$quantidade" | bc`
					#echo $total_da_nota
				fi
			done
		
			
			string="$codigo_cliente $data_da_venda $codigo_produto $quantidade $modo_de_pagamento $valor_total"
			
			vetor_de_vendas[$linha]=$string;
		    
			
			
		fi 
		let linha=$linha+1;
	
	done
}

relatorio_total_a_receber()
{
	for j in ${!vetor_de_vendas[*]}
	do
		venda_como_string=${vetor_de_vendas[$j]}
		
		venda_como_vetor=(${venda_como_string})
		
		for i in ${!vetor_de_clientes[*]}
		do
			
			cliente_como_string=${vetor_de_clientes[$i]}
			cliente_como_vetor=(${cliente_como_string})
			
			if [ ${venda_como_vetor[0]} == ${cliente_como_vetor[0]} ] #&& [ ${venda_como_vetor[4]} == "F" ]
			then 
				
				
				cliente_como_vetor[8]=`echo "scale=2; ${cliente_como_vetor[8]}+${venda_como_vetor[5]}" | bc`
				cliente_como_string=${cliente_como_vetor[@]}
				vetor_de_clientes[$i]=$cliente_como_string
			fi
		done
	done
	
	echo "CODIGO;CLIENTE;ENDERECO;TELEFONE;DATA;TIPO;CPF_OU_CNPJ;IE;A_COBRAR" > 2-areceber.csv
	for j in ${!vetor_de_clientes[*]}
	do
		cliente_como_string=${vetor_de_clientes[$j]}
		cliente_como_vetor=(${cliente_como_string})
		
		echo ${cliente_como_vetor[1]}";"${cliente_como_vetor[2]}";"${cliente_como_vetor[3]}";"${cliente_como_vetor[4]}";"${cliente_como_vetor[5]}";"${cliente_como_vetor[6]}";"${cliente_como_vetor[7]}";"${cliente_como_vetor[8]} >> 2-areceberteste.csv
		sort 2-areceberteste.csv > 2-areceber.csv # ORGANIZA A SAÍDA POR ORDEM ALFABÉTICA.
		
	done
}

#-c <arquivo>  -f <arquivo>  -p <arquivo>  -a <arquivo>  -v <arquivo> 
if [ $1 = "-c" ] && [ $3 = "-f" ] && [ $5 = "-p" ] && [ $7 = "-a" ] && [ $9 = "-v" ] 
then 
	cadastro_de_fornecedores < $4
	cadastro_de_clientes < $2
	cadastro_de_produtos < $6
	cadastro_de_compras < $8
	cadastro_de_vendas < ${10}
	relatorio_total_a_pagar
	relatorio_total_a_receber
	rm -rf 1-apagarteste.csv # DELETA O ARQUIVO TESTE CRIADO.
	rm -rf 2-areceberteste.csv # DELETA O ARQUIVO TESTE CRIADO.
else
	echo "ALGUMA ESTA ERRADO"
fi
#echo ${vetor_de_fornecedores[@]}
#echo ${vetor_de_clientes[@]}
#echo ${vetor_de_produtos[@]}
#echo ${vetor_de_compras[@]}
#echo ${vetor_de_vendas[@]}

